'''
Copyright (C) 2015 Rene Grzeszick. All rights reserved.
This file made available under the terms of the BSD license (see the Copyright.txt).

Created on Nov 21, 2012
'''

import os

class LineListIO(object):
    '''
    Serialization object that creates a list representation using single lines in a text file
    '''

    @staticmethod
    def read_list(filepath):
        '''
        Reads a list from the given filepath
        '''
        
        if not os.path.exists(filepath):
            raise ValueError('File for reading list does NOT exist: ' + filepath)
        
        stream = open(filepath)
        linelist = []
        for line in stream:
            line = line.strip()
            if line != '':
                linelist.append(line)
                
        stream.close()
        
        return linelist

    @staticmethod
    def write_list(file_path, line_list):
        '''
        Writes a list into the given file object
        
        file_path: the file path that will be written to
        line_list: the list of strings that will be written
        '''
        
        f = open(file_path, 'w')
        for l in line_list:
            f.write(l + '\n')
        f.flush()
        f.close()
