'''
Copyright (C) 2015 Rene Grzeszick. All rights reserved.
This file made available under the terms of the BSD license (see the Copyright.txt).

Created on Jun 30, 2014
'''


import cPickle

class SerializationIO(object):
    '''
    Serialization object that uses cPickle to load/save arbitrary data
    '''

    def __init__(self):
        '''
        Constructor
        '''
    
    @staticmethod
    def store_data(X, path):
        '''
        Stores any python variable/datacontainer at the given path
        Uses cPickle and binary format, which is much faster than pickle and the binary format also uses less space
        '''
        try:
            fileStream = open(path, "w") # write mode
            cPickle.dump(X, fileStream, 1)
            fileStream.close()
        except:
            raise IOError("Byte file could not be stored")
        return 
    
    @staticmethod
    def load_data(path):
        '''Loads any python variable/datacontainer at the given path'''
        try:
            fileStream = open(path, "r") # read mode
            X = cPickle.load(fileStream)
            fileStream.close()
        except:
            raise IOError("Byte file could not be read")
        return X
        
