'''
SIFT demo file

@author   Andrea Vedaldi
@author   Mikael Rousson (Python wrapping)
'''

import Image
import numpy
import pylab
import vlfeat
from plotop.vl_plotframe import vl_plotframe
from numpy.random import shuffle



if __name__ == '__main__':
	# VL_DEMO_SIFT_BASIC  Demo: SIFT: basic functionality
	
	# --------------------------------------------------------------------
	#                     Load a figure
	# --------------------------------------------------------------------
	I = Image.open('/home/rgrzeszi/Pictures/p5/P_hoch_5 Preis 2013_mini.jpg')
	
	# Plot rgb image
	pylab.imshow(I.transpose(Image.FLIP_TOP_BOTTOM))
	pylab.axis('off')
	
	# --------------------------------------------------------------------
	#                                                             Run SIFT
	#						 TODO: Replace me by Dense SIFT extractor call
	# --------------------------------------------------------------------
	I = vlfeat.vl_rgb2gray(numpy.array(I))	
	I = numpy.array(I, 'f', order='F') # 'F' = column-major order!
	f, d = vlfeat.vl_sift(I)


	# --------------------------------------------------------------------
	#                                                     Plot SIFT frames
	# --------------------------------------------------------------------
	sel = numpy.arange(f.shape[1])	
	shuffle(sel)
	vl_plotframe(f[:, sel[:50]], color='k', linewidth=3)
	vl_plotframe(f[:, sel[:50]], color='y')
	
	pylab.show()
	
	# --------------------------------------------------------------------
	#                     Minimal example ends here :-)
	# --------------------------------------------------------------------
	exit(0)


	# --------------------------------------------------------------------
	#                                                      Custom keypoint
	# --------------------------------------------------------------------
	print 'sift_basic_2'
	pylab.figure()
	pylab.imshow(I[:200,:200]) 

	fc = numpy.array([99, 99, 10, -numpy.pi/8], 'float64')
	fc = numpy.array(numpy.atleast_2d(fc).transpose(), order='F')
	f, d = vlfeat.vl_sift(I, frames=fc, verbose=False)

	vl_plotframe(f, color='k', linewidth=4)
	vl_plotframe(f, color='y', linewidth=2)
	

	# --------------------------------------------------------------------
	#                                   Custom keypoints with orientations
	# --------------------------------------------------------------------
	print 'sift_basic_3'
	pylab.figure()
	pylab.imshow(I[:200,:200]) 
	
	fc = numpy.array([99, 99, 10, 0], 'float64')
	fc = numpy.array(numpy.atleast_2d(fc).transpose(), order='F')
	f, d = vlfeat.vl_sift(I, frames=fc, orientations=True) ;
	
	vl_plotframe(f, color='k', linewidth=4)
	vl_plotframe(f, color='y', linewidth=2)
	
	pylab.show()
	
	
	