/*
 * pr_vlfeat.cpp
 *
 *  Created on: Apr 1, 2009
 *      Author: Mikael Rousson
 */


#include <boost/python.hpp>
#include <boost/python/suite/indexing/vector_indexing_suite.hpp>
#include <boost/python/overloads.hpp>

#define PY_ARRAY_UNIQUE_SYMBOL PyArrayVlfeat
#include <numpy/arrayobject.h> // in python/lib/site-packages/....

#include "py_vlfeat.h"

using namespace boost::python;
using namespace std;


void* extract_pyarray(PyObject* x)
{
	return x;
}


BOOST_PYTHON_MODULE(_vlfeat)
{
	converter::registry::insert(
	    &extract_pyarray, type_id<PyArrayObject>());

	def("vl_sift", vl_sift_python);
	def("vl_dsift", vl_dsift_python);
	def("vl_siftdescriptor", vl_siftdescriptor_python);
	def("vl_imsmooth", vl_imsmooth_python);


	import_array();
}

