/*
 * vl_erfill_python.h
 *
 *  Created on: Apr 30, 2009
 *      Author: Mikael Rousson
 */

#pragma once

#include "Python.h"
#include <vector>

#define PY_ARRAY_UNIQUE_SYMBOL PyArrayVlfeat
#define NO_IMPORT_ARRAY
#include <numpy/arrayobject.h> // in python/lib/site-packages/


#include <boost/python.hpp>
#include <boost/python/suite/indexing/vector_indexing_suite.hpp>
#include <boost/python/overloads.hpp>



/**
 *
 * @param image
 * @return
 */
PyObject * vl_sift_python(
		PyArrayObject & image,
		PyArrayObject & opt_frames,
		int opt_octaves = -1,
		int opt_levels = -1,
		int opt_first_octave = -1,
		double opt_peak_thresh = -1,
		double opt_edge_thresh = -1,
		double opt_norm_thresh = -1,
		double opt_magnif = -1,
		double opt_window_size = -1,
		bool opt_orientations = false,
		int opt_verbose = 0);

/**
 *
 * @param pyArray
 * @param opt_step
 * @param opt_bounds
 * @param opt_size
 * @param opt_fast
 * @param windowsize
 * @param opt_verbose
 * @param opt_norm
 * @return
 */
PyObject * vl_dsift_python(
		PyArrayObject & pyArray,
		int opt_step,
		PyArrayObject & opt_bounds,
		int opt_size,
		bool opt_fast,
		double windowsize,
		bool opt_verbose,
		bool opt_norm);

/**
 *
 * @param in_grad
 * @param in_frames
 * @return
 */
PyObject * vl_siftdescriptor_python(
		PyArrayObject & in_grad,
		PyArrayObject & in_frames);

/**
 *
 * @param image
 * @param sigma
 * @return
 */
PyObject * vl_imsmooth_python(PyArrayObject & image, double sigma);




